<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('map_module_title') ?></li>
    <li class="active"><?= $this->translate('territory_nav_list') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('territory') ?> <?= $this->translate('territory_module_title') ?>
</h1>

<div class="row row-padding">
    <div class="col-xs-12">
        <div class="panel" ng-controller="territoryListController as self">
            <table-builder options="self.options" items="self.territories" class="table-builder">
                <div class="panel-heading">
                    <?= $this->translate('territory_nav_list') ?>
                    <div class="panel-heading-right">
                        <div class="panel-heading-actions" ng-show="self.view == 'list'" tooltip="<?= $this->translate('tooltip_switch_view_territory_tree') ?>">
                            <?= $this->icon('tree', 'fa-fw pointer', ['ng-click' => 'self.view = \'tree\'; treeTabLoaded = true']) ?>
                        </div>
                        <div class="panel-heading-actions" ng-show="self.view == 'tree'" tooltip="<?= $this->translate('tooltip_switch_view_territory_list') ?>">
                            <?= $this->icon('list', 'fa-fw pointer', ['ng-click' => 'self.view = \'list\'']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_export_xls') ?>">
                            <?= $this->icon('excel', 'fa-fw pointer', ['ng-click' => '__tb.exportExcel()']) ?>
                        </div>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('tooltip_refresh') ?>">
                            <?= $this->icon('refresh', 'fa-fw pointer', ['ng-click' => '__tb.loadData()']) ?>
                        </div>
                    </div>
                </div>
                <div class="panel-body">
                    <div ng-show="self.view == 'list'">
                        <div class="row">
                            <div class="col-sm-4">
                                <div class="table-filters little-panel">
                                    <div class="title table-filters-header">
                                        <div class="input-group">
                                            <div class="input-group-addon pointer" data-toggle="collapse" href="#filters-collapsed">
                                                <?= $this->icon('filters', 'fa-fw') ?>
                                                <span class="caret"></span>
                                            </div>
                                            <input type="text" placeholder="<?= $this->translate('search', null, null, false) ?>" class="form-control"
                                                   ng-model="self.fullText" id="full-text" on-enter="self.fullTextSearch()"/>
                                            <div class="input-group-addon pointer" ng-click="self.fullTextSearch()">
                                                <?= $this->icon('search', 'fa-fw') ?>
                                            </div>
                                        </div>
                                    </div>
                                    <div id="filters-collapsed" class="body collapse">
                                        <?= $this->tableFilter('__tb.apiParams.search.data.filters', $this->territoryFilters()); ?>
                                        <div class="row">
                                            <div class="col-xs-6">
                                                <button class="btn" ng-click="self.resetfullTextSearch(); __tb.resetFilters(); __tb.loadData()"><?= $this->translate('table_filter_reset_button') ?></button>
                                            </div>
                                            <div class="col-xs-6 text-right">
                                                <button class="btn" ng-click="self.resetfullTextSearch(); __tb.loadData()">
                                                    <?= $this->icon('search', 'fa-fw') ?>
                                                    <?= $this->translate('table_filter_button') ?>
                                                </button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-sm-4">
                                <table-builder-columns></table-builder-columns>
                            </div>
                            <?php if ($this->acl()->isAllowed('application:e:query:r')) : ?>
                                <div class="col-sm-4">
                                    <table-builder-queries></table-builder-queries>
                                </div>
                            <?php endif; ?>
                        </div>
                        <div class="row">
                            <div class="col-xs-12">
                                <div ng-show="__tb.isAnItemSelected()"
                                     class="btn-group">
                                    <button ng-click="__tb.removeFromList()"
                                            class="btn btn-xs"
                                            type="button"
                                            tooltip="<?= $this->translate('tooltip_remove_from_list') ?>">
                                        <?= $this->icon('eraser') ?>
                                    </button>

                                    <?php if ($this->acl()->isAllowed('map:e:territory:d')) : ?>
                                        <button ng-click="self.showFusionModal()"
                                                class="btn btn-xs"
                                                type="button"
                                                tooltip="<?= $this->translate('fusion') ?>">
                                            <?= $this->icon('fusion') ?>
                                        </button>
                                    <?php endif ?>
                                </div>
                                <form name="territoryForm">
                                    <table table-builder-table class="table table-bordered table-condensed table-hover">
                                        <thead>
                                            <tr>
                                                <th tb-column tb-name="selection" class="checkbox-column"><input type="checkbox" ng-model="__tb.selection"/></th>
                                                <th tb-column tb-name="name" tb-sortable="true" tb-toggle="true"><?= $this->translate('territory_field_name') ?></th>
                                                <th tb-column tb-name="code" tb-sortable="true" tb-toggle="true"><?= $this->translate('territory_field_code') ?></th>
                                                <th tb-column tb-name="children.name" tb-sortable="true" tb-toggle="true"><?= $this->translate('territory_field_children') ?></th>                                                
                                                <?php
                                                if ($this->module()->isActive('keyword')) {
                                                    foreach ($this->groups as $group) {
                                                        echo '<th tb-column tb-name="keyword' . $group->getId() . '" tb-sortable="false" tb-toggle="true">' . $group->getName() . '</th>';
                                                    }
                                                }
                                                ?>
                                                <th tb-column tb-name="createdAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('territory_field_createdAt') ?></th>
                                                <th tb-column tb-name="updatedAt" tb-sortable="true" tb-toggle="true" tb-hidden="true"><?= $this->translate('territory_field_updatedAt') ?></th>
                                                <th tb-column tb-name="actions" class="actions-column"></th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            <tr ng-repeat="territory in self.territories" ng-class="{editing: self.editedLine == territory}">
                                                <td><input type="checkbox" ng-model="territory.selected"/></td>
                                                <td class="editable">
                                                    <span ng-show="self.editedLine !== territory">
                                                        <a ng-if="territory._rights.read" href="<?= $this->url('map/territory/form') ?>/{{territory.id}}">{{territory.name}}</a>
                                                        <span ng-if="!territory._rights.read">{{territory.name}}</span>

                                                        <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(territory)', 'ng-if' => 'territory._rights.update']) ?>
                                                    </span>
                                                    <span ng-if="self.editedLine == territory">
                                                        <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.name" required/>
                                                        <field-errors field="name" errors="self.editedLineErrors"></field-errors>
                                                    </span>
                                                </td>
                                                <td class="editable">
                                                    <span ng-show="self.editedLine !== territory">
                                                        {{territory.code}}
                                                        <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(territory)', 'ng-if' => 'territory._rights.update']) ?>
                                                    </span>
                                                    <span ng-if="self.editedLine == territory">
                                                        <input type="text" class="form-control input-sm" ng-model="self.editedLineFields.code"/>
                                                        <field-errors field="code" errors="self.editedLineErrors"></field-errors>
                                                    </span>
                                                </td>
                                                <td class="editable">
                                                    <span ng-show="self.editedLine !== territory">
                                                        <span class="comma-separated" ng-show="self.editedLine !== territory">
                                                            <span ng-repeat="children in territory.children">
                                                                {{ children.name }}
                                                            </span>
                                                        </span>
                                                        <?= $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(territory)', 'ng-if' => 'territory._rights.update']) ?>
                                                    </span>
                                                    <span ng-if="self.editedLine == territory">
                                                        <territory-select ng-model="self.editedLineFields.children" multiple="true"></territory-select>
                                                        <field-errors field="children" errors="self.editedLineErrors"></field-errors>
                                                    </span>
                                                </td>
                                                <?php
                                                if ($this->module()->isActive('keyword')) {
                                                    foreach ($this->groups as $group) {
                                                        echo '<td class="editable">';
                                                        echo '<span class="comma-separated" ng-show="self.editedLine !== territory">';
                                                        echo '<span ng-repeat="keyword in territory.keywords[' . $group->getId() . ']">{{keyword.name}}</span>';
                                                        echo $this->icon('inline-edit', '', ['ng-click' => 'self.editLine(territory)', 'ng-if' => 'territory._rights.update']);
                                                        echo '</span>';
                                                        echo '<span ng-if="self.editedLine == territory">';
                                                        echo '<keyword-select ng-model="self.editedLineFields.keywords[' . $group->getId() . ']" multiple="' . ($group->isMultiple() ? 'true' : 'false') . '" configuration="{ service : { apiParams : { search: { data: { filters: { group : { op: \'eq\', val: ' . $group->getId() . ' } } } } } } }"></keyword-select>';
                                                        echo '</span>';
                                                        echo '</td>';
                                                    }
                                                }
                                                ?>
                                                <td>{{territory.createdAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                                <td>{{territory.updatedAt | dateFormat : 'DD/MM/YYYY'}}</td>
                                                <td>
                                                    <div class="btn-group btn-group-actions" ng-if="self.editedLine !== territory">
                                                        <?php if ($this->acl()->isAllowed('map:e:territory:r')) : ?>
                                                            <a ng-if="territory._rights.read" href="<?= $this->url('map/territory/form') ?>/{{territory.id}}" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                                <?= $this->icon('edit') ?>
                                                            </a>
                                                        <?php endif; ?>

                                                        <?php if ($this->acl()->isAllowed('map:e:territory:d')) : ?>
                                                            <a ng-if="territory._rights.delete" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>" ng-click="self.deleteTerritory(territory)">
                                                                <?= $this->icon('delete') ?>
                                                            </a>
                                                        <?php endif; ?>
                                                    </div>
                                                    <div class="btn-group btn-group-actions" ng-if="self.editedLine == territory">
                                                        <button class="btn btn-xs btn-default" ng-click="self.saveEditedLine(territory)" type="submit" tooltip="<?= $this->translate('tooltip_save') ?>">
                                                            <?= $this->icon('save') ?>
                                                        </button>
                                                        <button class="btn btn-xs btn-default" ng-click="self.editedLine = null" type="button" tooltip="<?= $this->translate('tooltip_cancel') ?>">
                                                            <?= $this->icon('close') ?>
                                                        </button>
                                                    </div>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </form>
                            </div>
                        </div>
                    </div>
                    <div ng-if="treeTabLoaded" ng-show="self.view == 'tree'">
                        <?= $this->partial('map/partial/tree') ?>
                    </div>
                </div>
            </table-builder>

            <div class="modal" id="fusionModal">
                <div class="modal-dialog">
                    <div class="modal-content">
                        <div class="modal-header">
                            <h4 class="modal-title"><?= $this->translate('territory_fusion_title') ?></h4>
                        </div>
                        <div class="modal-body">
                            <div class="row" style="margin-bottom: 10px;">
                                <div class="col-xs-12">
                                    <label for="fusion.territoryToKeep">
                                        <?= $this->translate('fusion_field_territoryToKeep') ?>
                                    </label>
                                    <territory-select ng-model="self.fusion.territoryToKeep"></territory-select>
                                </div>
                            </div>
                        </div>
                        <div class="modal-footer">
                            <button class="btn btn-default" type="button" data-dismiss="modal">
                                <?= $this->translate('close') ?>
                            </button>

                            <button class="btn btn-submit" ng-disabled="self.loading.fusion"
                                    ng-click="self.doFusion()">
                                <?= $this->icon('loading', '', ['ng-if' => 'self.loading.fusion']) ?>
                                <?= $this->translate('fusion') ?>
                            </button>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<?php
$fabLinks = [];

if ($this->acl()->isAllowed('map:e:territory:c')) {
    $fabLinks[] = [
        'href' => $this->url('map/territory/form'),
        'text' => $this->icon('create', 'fa-fw') . ' ' . $this->translate('territory_nav_form'),
    ];
    $fabLinks[] = [
        'href' => $this->url('map/territory/import'),
        'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('territory_nav_import'),
    ];
}

echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/map/service/territory.js');
$this->angular('js/src/application/query/service/query.js');

$this->angular('js/src/map/directive/territorySelect.js');
$this->angular('js/src/map/controller/territory/list.js');
$this->angular('js/src/map/controller/territory/tree.js');

$this->angular('js/src/keyword/directive/keywordSelect.js');
$this->angular('js/src/keyword/service/keyword.js');

